﻿// #FootnoteOfHeaderInTwoColumnText.jsx

#targetengine "FootnoteInTable"

var programTitul = "Сноска заголовка в многоколоннике • 27.01.2019";

////////////
function myFile(myFileName) {
var myScriptFile = myGetScriptPath();
var myScriptFolder = decodeURI(myScriptFile.path);
var myFilePath = decodeURI(myScriptFolder + "/" +myFileName);
return myFilePath;
} //myFile
//
function myGetScriptPath() {
	try{
		return app.activeScript;
	}
	catch(myError){
		return File(myError.fileName);
	}
} //myGetScriptPath()

//>>  темный экран / светлый экран >>>>>
// defSelColor: цвет фона кнопки, когда в её пространстве окажется курсор. Первые три числа: RGB, 0 - мин, 1 - макс.
// defBgColor:  цвет, который приобретёт фон кнопки, когда курсор покинет её пространство.
try {
    var uiBr = app.generalPreferences.uiBrightnessPreference;
    }
catch (e) {  // до СС темного варианта интерфейса не было
    uiBr = 0.6;
    }
if (uiBr == 1 || uiBr > 0.67) { 
    defBgColor = [.85,.85,.85, 1];  defSelColor = [.15,.15,.15, 1]; 
    }
else if (uiBr == 0.67 || uiBr > 0.33) { 
    defBgColor = [.7,.7,.7, 1]; defSelColor = [.3,.3,.3, 1]; 
    }
else if (uiBr == 0.33 || uiBr > 0) { 
    defBgColor = [.34,.34,.34, 1];  defSelColor = [.66,.66,.66, 1]; 
    }
else { // uiBr == 0
     defBgColor = [.2,.2,.2, 1];  defSelColor = [.8,.8,.8, 1];
    }
    
////>>>> темный экран / светлый экран >>>>>

///////////////////////////////////////////
//var MainWinLocation = [-1,-1]; // положение на экране основного окна программы
var buttonSize = [0,0, 160,30];
var infoSize = [0,0,30,30];
var docFootnoteOptions = {}; // три параметра:  .footnoteNumberingStyle   .restartNumbering   .startAt
var footnoteNumberingStyle = ["ARABIC", "ASTERISKS", "SYMBOLS", "SINGLE_LEADING_ZEROS", "DOUBLE_LEADING_ZEROS", "LOWER_LETTERS", "UPPER_LETTERS", "UPPER_ROMAN", "LOWER_ROMAN"]; 
var restartNumbering = ["DONT_RESTART", "PAGE_RESTART", "SECTION_RESTART", "SPREAD_RESTART"]; // FootnoteRestarting
var symbols = ["*", "†", "‡", "§", "¶"];

var fnOptions;
var myStory;
var note = false;
var nFn;
var newPosition;
var fnIndex;
var selndex;
var theNomer;
var headerId, storyId, headerPage, wordPage;

var problemMess09 = "Ошибка обработки сносок";
problemMess12 = "Ошибка обработки сносок при использовании форматов  LOWER_LETTERS или UPPER_LETTERS";

var parseIntAppVersion = parseInt (app.version);
if (parseIntAppVersion < 6) { // app.version
	alert ("Этот скрипт предназначен для обработки текста в InDesign CS4+.", " Подготовка текста к вёрстке ");
    exit();
    } // app.version

var myDoc = app.activeDocument; 
var mySel = app.selection[0];
app.clipboardPreferences.preferStyledTextWhenPasting = true; // вставка буфера со всем оформлением
app.toolBoxTools.currentTool = UITools.TYPE_TOOL;

var win = new Window ("palette", "Сноска заголовка", undefined, {closeButton: true});
//if (MainWinLocation[0] != -1) win.location = MainWinLocation;
win.alignChildren = ["fill", "center"];
win.orientation = "row";
//var panel = win.add("panel");
//panel.alignChildren = ["left", "fill"];
var selected = win.add("checkbox", undefined, "Сноска");
selected.helpTip = "Выделите знак сноски в заголовке и установите флажок";
var placed = win.add("checkbox", undefined, "Слово");
placed.helpTip = "Поместите курсор в слово первой строки текста или выберите это слово и установите флажок. В обоих случаях рядом с этим словом будет помещена скрытая сноска, а в случае выбора слова рядом с ним будет ещё и маркер, отмечающий место этой сноски.";
placed.enabled = false;
//var buttons = win.add("group");
//buttons.alignChildren = ["fill", "center"];
var info = win.add("button", infoSize, "?");
var tips = win.add("button", infoSize, "i");
tipShow = true;
tips.helpTip = "Включение/выключение подсказок";
///
tips.onClick = function () { // tips.onClick
if (tipShow == true)  { // tipShow == true
    selected.helpTip = "";    
    placed.helpTip = "";   
    tips.text = "...";
    tipShow = false;
    } // tipShow == true
else {
    selected.helpTip = "Выделите знак сноски в заголовке и установите флажок";    
    placed.helpTip = "Поместите курсор в слово первой строки текста или выберите это слово и установите флажок. В обоих случаях рядом с этим словом будет помещена скрытая сноска, а в случае выбора слова рядом с ним будет ещё и маркер, отмечающий место этой сноски.";
    tips.text = "i";   
   tipShow = true;
    }    
} // tips.onClick
///
info.onClick = function () { // info.onClick
var tekst = "В многоколоннике Индизайн стандартно помещает сноски в той колонке, где она появилась. И не смотря на то, что начиная с версии 2017 сноски можно развёрстывать на ширину всех колонок, пока многие предпочитают вариант размещения сносок по колонкам.\nТекст надо размещать по колонкам, а заголовок часто должен быть на формат полосы, и такой вариант поддерживается индизайном достаточно давно.\nНо как оказалось, есть конфликт в объединении колонок для создания распашного заголовка и варианта оформления сносок, когда каждая сноска в своей колонке. Проблема в том, что если у заголовка тоже есть сноска, то она будет завёрстана сразу под заголовком на всю его ширину.\n\nИсправить это можно так:\n- сделать сноску в слове первой строки, сразу под заголовком. Текст этой сноски точно такой же, как у сноски заголовка, и оформление стилями для сносок;\n- знак сноски в тексте сделать невидимым: кегль 0,1 пт, масштаб по горизонтали 1%, бесцветный;\n- настоящую сноску в заголовке удалить, а на место знака сноски поставить символы, повторяющие номер этой сноски. Число или звёздочка, в зависимости от выбранного варианта. Они должны быть оформлены тем же символьным стилем, что все знаки сносок.\n\nЕсли делать это руками, то это нудно и скучно. А скрипт сделает за вас это мгновенно.\n\nЧто для этого нужно.\n- в вёрстке должны быть определены символьный стиль для знака сноски и абзацный стиль оформления сноски;\n- в настройках абзацного стиля на вкладке «Буквицы и вложенные стили» должен быть определён порядок оформления знака сноски одним из символьных стилей;\n- эти стили оформления сносок, символьный и абзацный, должны быть указаны в настройках оформления сносок Текст > Параметры сносок документа.\n\nЕсли это есть, то всё готово для решения этой проблемы.\nЗапускаем скрипт FootnoteOfHeader.jsx.\n- выделяем знак сноски в заголовке и подтверждаем выбор установкой флажка «Сноска»;\n- ставим курсор в одно из слов в первой строке и подтверждаем установкой флажка «Слово».\nПосле этого скрипт выполнит все описанные выше шаги по переносу сноски в текст, маскированию этой сноски и помещению в заголовок символов — заменителей знака сноски.\nСкрипт сам создаст символьный стиль для маскировки сноски в тексте. Стиль называется «#maskFootnote» и размещён в группе «#HiddenFootnote».\n\nЕсли важно держать под контролем, куда скрипт спрятал сноску, то вместо помещения курсора в слово надо это слово выделить, и программа рядом с добавленной сноской поместит маркер примечания. В тексте каждого такого примечания будет указан номер сноски, рядом с которой он поставлен.\n\nКрайняя справа кнопка — это управление показом всплывающих подсказок к кнопкам. Вид кнопки «i» — показ подсказок включён, когда кнопка такая «…», подсказки не выводятся.\n\nПосле каждой процедуры оформления сносок в заголовке окно скрипта остаётся на экране. Его можно задвинуть за край экрана и вытягивать, когда нужно. Для прекращения работы скрипта щелкните по крестику в шапке окна.\n\nВопросы, предложения, идеи — пишите m.ivanyushin@gmail.com\nМихаил Иванюшин\n\n";    
var wn = new Window ("dialog", programTitul);
var data = wn.add("edittext", [0, 0, 850, 500], tekst, {multiline: true});
wn.layout.layout();
wn.show();
return;
} // info.onClick
///
selected.onClick = function () { // selected.onClick
mySel = app.selection[0];    
if (mySel == null || mySel.length != 1 || mySel.constructor.name != "Character") {
    alert("Сноска не выбрана.", programTitul);
    selected.value = false;    
    return;
    }
fnOptions = myDoc.footnoteOptions;
myStory = mySel.parentStory;
selndex = mySel.index;
getDocFootnoteSetttings(); // считали текущие установки оформления сносок
footnoteNotFound = true;
theFootnotes = myStory.footnotes.everyItem().getElements();
for (f = 0; f < theFootnotes.length; f++) { // f++
    fnIndex = theFootnotes[f].storyOffset.index;
    if (fnIndex != selndex) continue;
    footnoteNotFound = false;
    break;
    } // f++
if (footnoteNotFound) {
    alert("Выделенный символ не является сноской.", programTitul);
    selected.value = false;
    return;
    }
nFn = theFootnotes[f];
fnD = {};
fnD.index = nFn.index - myStory.footnotes[0].index; // индекс сноски
fnD.textIndex = nFn.storyOffset.index; // позиция сноски в тексте статьи
fnD.page = myStory.insertionPoints[fnD.textIndex].parentTextFrames[0].parentPage.name; // номер страницы, на которой сноска
fnD.pindex = myStory.insertionPoints[fnD.textIndex].parentTextFrames[0].parentPage.index; // индекс страницы не развороте.      
fnD.id = nFn.id;
// получим строку, которую надо поместить на место сноски
theNomer = String(getRealNumber (fnD.index, fnD.textIndex, fnD.page, fnD.pindex, myStory,docFootnoteOptions.startAt, docFootnoteOptions.footnoteNumberingStyle, docFootnoteOptions.restartNumbering, fnD.id));        
selected.enabled = false;
placed.enabled = true;
headerId = myStory.id;
if (parseIntAppVersion == 6) { mySel.parentTextFrames[0].parent.name }
else { headerPage = mySel.parentTextFrames[0].parentPage.name};
// Строки до конца программы для того, чтобы убрать выборку кнопок меню.
// Эта выборка к делу не относится, но появляется после манипуляций с флажками
app.selection = NothingEnum.NOTHING;
myStory.insertionPoints[fnD.textIndex].select();
app.selection = NothingEnum.NOTHING;
app.toolBoxTools.currentTool = UITools.TYPE_TOOL;
} // selected.onClick
///
placed.onClick = function () { // placed.onClick
mySel = app.selection[0];
note = false;
if (mySel.parent.constructor.name == "Footnote") {
    alert("В сноске сноску сохранять нельзя.", programTitul);
    placed.value = false;
    return;    
    }
if (mySel == null || (mySel.constructor.name != "InsertionPoint" && mySel.constructor.name != "Word")) {
    alert("Курсор должен быть в слове, рядом с которым надо поместить скрытую сноску. Если это слово будет выбрано, то место размещения скрытой сноски будет отмечено маркером примечания.", programTitul);
    placed.value = false;
    return;
    }
if (mySel.constructor.name == "Word") {
    note = true;
    }
storyId = mySel.parentStory.id;
if (storyId != headerId) {
    alert("Сноска была выбрана в другой статье, не в той, что выбрана сейчас.", programTitul);
    placed.value = false;    
    return;    
    }
if (parseIntAppVersion == 6) { wordPage = mySel.parentTextFrames[0].parent.name }
else { wordPage = mySel.parentTextFrames[0].parentPage.name };
if (wordPage != headerPage) {
    alert("Выбранное слово находится не на той странице, где была отмечена сноска.", programTitul);
    placed.value = false;    
    return;     
    }
fnOptions = myDoc.footnoteOptions;
myStory = mySel.parentStory;
var selndex = mySel.index;
getDocFootnoteSetttings(); // считали текущие установки оформления сносок
footnoteNotFound = true;
theFootnotes = myStory.footnotes.everyItem().getElements();

newPosition = mySel.words[0].index + mySel.words[0].length; // позиция после слова
myStory.insertionPoints[newPosition].select(); // выделяем точку вставки после слова...
thePosition = app.selection[0]; // ... сохраняем в переменной thePosition
var newFn = thePosition.footnotes.add(); // в этой позиции новая сноска
var firstFootnoteLength = theFootnotes[0].texts[0].length; // длина текста первой сноски
theFootnotes[0].texts[0].characters.itemByRange(2,firstFootnoteLength-1).select(); // в самой сноске выделяем текст сразу после шпации, идущей за знаком сноски и до конца
app.copy(); // копируем в буфер
newFn.texts[0].insertionPoints[-1].select(); // активируем вставку в текст только что созданной сноски
app.paste(); // и вставляем
newFn.texts[0].paragraphs[0].appliedParagraphStyle = fnOptions.footnoteTextStyle; // прикладываем к вставленному тексту установленный для сносок абзацный стиль
if (newFn.texts[0].paragraphs.length > 1) { // paragraphs.length > 1 ||  цикл, если сноска в несколько абзацев, и есть назначение, каким стилем оформлять первый абзац сноски, каким остальные.
    for (var n = 1; n < newFn.texts[0].paragraphs.length; n++)  { // n++
        newFn.texts[0].paragraphs[n].appliedParagraphStyle = theFootnotes[0].texts[0].paragraphs[n-1].appliedParagraphStyle.nextStyle;   
        } // n++
    } // paragraphs.length > 1
var lastChar = newFn.texts[0].paragraphs[-1].characters[-1];
if (lastChar.contents == "\r" || lastChar.contents == "\n") lastChar.remove(); // если в перенесённой сноске последний знак перевод строки, то тут он удаляется.
myStory.characters[thePosition.index-1].select();

// в группе '#HiddenFootnote' символьный стиль '#maskFootnote' для оформления скрытой сноски
if( myDoc.characterStyleGroups.item( "#HiddenFootnote" ) == null)  {
    var group = myDoc.characterStyleGroups.add({ name: "#HiddenFootnote" }); 
     group.characterStyles.add({name:"#maskFootnote", pointSize:0.1, horizontalScale:1, strokeColor:"None", fillColor:"None"});  
    }
var specCharStyle = myDoc.characterStyleGroups.item("#HiddenFootnote").characterStyles.item("#maskFootnote");
app.selection[0].appliedCharacterStyle = specCharStyle;

if (note == true) { // note.value
    myStory.insertionPoints[newPosition].select();
    notePoint = app.selection[0];  
    notePoint.position = Position.NORMAL;
    noteInStory = notePoint.notes.add();
    noteInStory.texts[0].contents = "Сноска: " + theNomer;
    } // note.value
fnIndex = nFn.storyOffset.index;
myStory.insertionPoints[fnIndex].contents = theNomer;
myStory.characters.itemByRange(fnIndex, fnIndex + theNomer.length -1).select();
app.selection[0].appliedCharacterStyle = fnOptions.footnoteMarkerStyle;
nFn.remove();
myStory.recompose();
app.selection = NothingEnum.NOTHING;
selected.enabled = true;
placed.enabled = false;
selected.value = false;
placed.value = false;
// Четыре следующих строки -- без них после завершения обработки в меню оказывается выбранной одна из кнопок.
// Некрасиво. Поэтому искусственно выбираем точку вставки, это снимает, так скажем, фокус внимания программы с окна скрипта, и снимаем выборку в тексте.
// И окно скрипта, кстати, после завершения обработки неактивно.
// Активация инстумента работы с текстом, пожалуй, это лишнее, т.к. сейчас именно этот инструмент активен.
app.selection = NothingEnum.NOTHING;
myStory.insertionPoints[fnD.textIndex].select();
app.selection = NothingEnum.NOTHING;
app.toolBoxTools.currentTool = UITools.TYPE_TOOL;
///
app.activeWindow.zoom (ZoomOptions.fitPage); // на экране вся страница
} // placed.onClick
///
win.show();
////////////
function getDocFootnoteSetttings() { // getDocFootnoteSetttings || считать установки оформления сносок
var fnOptions = app.activeDocument.footnoteOptions;
var fNS = String(fnOptions.footnoteNumberingStyle);
var rez;
if (rez = testOption(fNS, footnoteNumberingStyle, "Стиль нумерации сносок", "не поддерживается.") == null) return null;
else docFootnoteOptions.footnoteNumberingStyle = fNS;
var fR = String(fnOptions.restartNumbering);
if (rez = testOption(fR, restartNumbering, "Вариант перезапуска нумерации", "не поддерживается.") == null) return null;
else docFootnoteOptions.restartNumbering = fR.split("_")[0];
docFootnoteOptions.startAt = fnOptions.startAt;
} // getDocFootnoteSetttings
///
function testOption(opt, array, mess1, mess2) { // testOption
optionNotFound = true;
for (var i = 0; i < array.length; i++) { // i++
    if (opt != array[i]) continue;
    optionNotFound = false;
    break;
    } // i++
if (optionNotFound == true) {
    alert(mess1 + " "+ opt + " " + mess2,programTitul); 
    return null;
    }
return 0;
} // testOption
function getRealNumber (index, textIndex, page, pindex, story, startAt, format, restart,fnid) { // получение реального номера/вида сноски для помещения в ячейку
// index -- индекс сноски,
// textIndex -- смещение в статье до точки вставки сноски,  
// page -- страница, где эта сноска, 
// pindex -- индекс страницы на развороте
// story -- статья, в которой сноска,  
// format -- вариант оформления номера сноски,  
// restart -- состояние указателя "начинать заново с новой страницы", "DONT", "PAGE", "SECTION
// fnData.index   fnData.startAt    fnData.numbFormat    fnData.page    fnData.restartNumbering   fnData.story 
// fnid -- идентификатор сноски
///
if (restart == "SPREAD") { // SPREAD
  if (app.activeDocument.documentPreferences.facingPages == false) restart = "PAGE";
  /*  else*/ if (pindex > 1) {
        alert(_restriction1);
        return null;          
        }
    else { // pindex == 1 или 0      
        tF = myStory.insertionPoints[textIndex].parentTextFrames[0]; // фрейм, в котором сноска   
        fnLength = tF.footnotes.length; // число сносок на этой странице  
        var parseIntAppVersion = parseInt (app.version);
        var pN;
        try { if (parseIntAppVersion > 6) pN = tF.parentPage else pN = tF.parent } catch (e) { }   
       // $.writeln("pN = " + pN.name + " | pN.documentOffset : " + pN.documentOffset);
        if (pN.documentOffset%2 == 1) {  // == 1 - это левая, т.е. чётная страница 
            infoForSpreadNum.fn = fnLength;
            infoForSpreadNum.id = tF.id;        
            // $.writeln("infoForSpreadNum.id = " + infoForSpreadNum.id);
            fnNotFound = true;
            for (var i = 0; i < fnLength; i++) { // i++
                if (tF.footnotes[i].id != fnid) continue;
                fnNotFound = false;
                break;
                } // i++
            if (fnNotFound == true) {
                alert(problemMess09); // не найдена сноска, номер которой надо узнать (эта проверка этапа отладки программы)
                return null;        
                }
            index = i + Number(startAt); 
            app.documents[0].select(NothingEnum.nothing); // снимем выделение
            } // == 1
        else { // == 0 -- это правая, т.е. нечетная страница
            fnNotFound = true;
            for (var i = 0; i < fnLength; i++) { // i++
                if (tF.footnotes[i].id != fnid) continue;
                fnNotFound = false;
                break;
                } // i++
            if (fnNotFound == true) {
                alert(problemMess09); // не найдена сноска, номер которой надо узнать (эта проверка этапа отладки программы)
                return null;        
                }
            spDelta = 0;
            if (tF.previousTextFrame.id == infoForSpreadNum.id) spDelta = infoForSpreadNum.fn;
            index = i + Number(startAt) + Number(spDelta);     
            app.documents[0].select(NothingEnum.nothing); // снимем выделение
            } // == 0
        } // pindex == 1
    }  // SPREAD

else if (restart == "PAGE") { // PAGE
        tF = myStory.insertionPoints[textIndex].parentTextFrames[0]; // фрейм, в котором сноска   
        fnLength = tF.footnotes.length; // число сносок на этой странице
        fnNotFound = true;
        for (var i = 0; i < fnLength; i++) { // i++
            if (tF.footnotes[i].id != fnid) continue;
            fnNotFound = false;
            break;
            } // i++
        if (fnNotFound == true) {
            alert(problemMess09); // не найдена сноска, номер которой надо узнать (эта проверка этапа отладки программы)
            return null;        
             }
        index = i + Number(startAt); 
        app.documents[0].select(NothingEnum.nothing); // снимем выделение
       } // PAGE     
   else index = Number(index) + Number(startAt);
    app.documents[0].select(NothingEnum.nothing); // снимем выделение    
    
// к этому моменту index равен номеру сноски. Теперь надо изменить его оформление.
    if (format == "ARABIC") return index;
    if (format == "SYMBOLS") { // SYMBOLS
        var frP = (index-1)%symbols.length;
        var intP = parseInt((index-1)/symbols.length);
        var symbolsLine = symbols[frP];
        for (var f = 0; f < intP; f++) symbolsLine = symbolsLine + symbols[frP];
        return symbolsLine;
        } // SYMBOLS
    if (format == "ASTERISKS") { // ASTERISKS
        var nmast = "";
        for (var a = 0; a < index; a++) nmast = nmast + "*";
        return nmast;
        } // ASTERISKS
    if (format == "LOWER_LETTERS" || format =="UPPER_LETTERS") { // LOWER - UPPER_LETTERS
        return (getNumberAsLetters (index,format));
        } // LOWER - UPPER_LETTERS
    if (format == "LOWER_ROMAN" || format =="UPPER_ROMAN") { // UPPER_LOWER_ROMAN
        return (getRomanNumber (index,format));
        } // UPPER_LOWER_ROMAN  
    if (format == "SINGLE_LEADING_ZEROS") { // "SINGLE_LEADING_ZEROS"
        if (index <= 9) index = "0" + index;
        return index;
        } // "SINGLE_LEADING_ZEROS"
    if (format == "DOUBLE_LEADING_ZEROS") { // "DOUBLE_LEADING_ZEROS"   
        if (index <= 9) index = "00" + index;
        else if (index <= 99) index = "0" + index;
        return index;
        } // "DOUBLE_LEADING_ZEROS"    
} // getRealNumber
function getNumberAsLetters (number,format) { // представление числа в виде латинских букв
// number -- это уже вычисленное число, с учётом delta -- число начала нумерации сносок;  small -- вариант используемых букв;  restart -- "начинать заново с новой страницы" 
// Все эти вычисления выполняются в функции getRealNumber
// format -- вариант представления чисел --  "LOWER_LETTERS" или "UPPER_LETTERS".
// максимальное число, представимое  двумя буквами латинского алфавита -- 702, это будет ZZ. Но этот скрипт корректно пересчитывает числа в "буквы" только до числа 701.
var letters = ["a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z","A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z"];
var bitArr = [];
if (format != "LOWER_LETTERS" && format != "UPPER_LETTERS") {
        alert(problemMess12); // ожидался один из форматов LOWER_LETTERS или UPPER_LETTERS, но этого не случилось
        return null;      
    }
if (number > 701) {
    alert(_restriction3);
    return null;
    }
littlePart = number;
if (number/26 > 1) { //  parseInt
    tmpNumber = number; 
    do {
        bigPart = parseInt(tmpNumber/26);
        // начиная с 702 значение bigPart становится равным 27.  Чтобы решить эту задачу, надо, видимо, делать рекурсивную обработку. Но сноски с такими большими номерами, да ещё чтобы использовались буквы -- это такая редкая редкость, что жалко времени на создание ненужного программного модуля.
        bitArr.push(bigPart);
        tmpNumber = tmpNumber - 26*bigPart;
        }
        while (bigPart > 26)
        bitArr.push(tmpNumber);
        littlePart = 0;
    } //  parseInt
var rezArr = [];
var bitArrLength = bitArr.length;
for (var i = 0; i <bitArrLength; i++) { // i++
    indx = bitArr.shift();    
    indx--;
    if (format == "UPPER_LETTERS") indx += 26;
    rezArr[i] = letters[indx];
    } // i++
var rezString = "";
if (littlePart != 0) { // littlePart != 0
    indx = littlePart;
    if (format == "UPPER_LETTERS") indx += 26;
    indx--;
    rezArr[i] = letters[indx];
    } // littlePart != 0
rezString = rezArr.join("");
return rezString;
} // getNumberAsLetters
function getRomanNumber (number, format) { // представление числа в виде римских цифр
// number -- это уже вычисленное число, с учётом delta -- число начала нумерации сносок;  small -- вариант используемых букв;  restart -- "начинать заново с новой страницы" 
// Все эти вычисления выполняются в функции getRealNumber
var rN, index;
var romanBigNumbers = ["I","II","III","IV","V","VI","VII","VIII","IX","X","XI","XII","XIII","XIV","XV","XVI","XVII","XVIII","XIX","XX","XXI","XXII","XXIII","XXIV","XXV","XXVI","XXVII","XXVIII","XXIX","XXX","XXXI","XXXII","XXXIII","XXXIV","XXXV","XXXVI","XXXVII","XXXVIII","XXXIX","XL","XLI","XLII","XLIII","XLIV","XLV","XLVI","XLVII","XLVIII","XLIX","L","LI","LII","LIII","LIV","LV","LVI","LVII","LVIII","LIX","LX","LXI","LXII","LXIII","LXIV","LXV","LXVI","LXVII","LXVIII","LXIX","LXX","LXXI","LXXII","LXXIII","LXXIV","LXXV","LXXVI","LXXVII","LXXVIII","LXXIX","LXXX","LXXXI","LXXXII","LXXXIII","LXXXIV","LXXXV","LXXXVI","LXXXVII","LXXXVIII","LXXXIX","XC","XCI","XCII","XCIII","XCIV","XCV","XCVI","XCVII","XCVIII","XCIX","C","CI","CII","CIII","CIV","CV","CVI","CVII","CVIII","CIX","CX","CXI","CXII","CXIII","CXIV","CXV","CXVI","CXVII","CXVIII","CXIX","CXX","CXXI","CXXII","CXXIII","CXXIV","CXXV","CXXVI","CXXVII","CXXVIII","CXXIX","CXXX","CXXXI","CXXXII","CXXXIII","CXXXIV","CXXXV","CXXXVI","CXXXVII","CXXXVIII","CXXXIX","CXL","CXLI","CXLII","CXLIII","CXLIV","CXLV","CXLVI","CXLVII","CXLVIII","CXLIX","CL","CLI","CLII","CLIII","CLIV","CLV","CLVI","CLVII","CLVIII","CLIX","CLX","CLXI","CLXII","CLXIII","CLXIV","CLXV","CLXVI","CLXVII","CLXVIII","CLXIX","CLXX","CLXXI","CLXXII","CLXXIII","CLXXIV","CLXXV","CLXXVI","CLXXVII","CLXXVIII","CLXXIX","CLXXX","CLXXXI","CLXXXII","CLXXXIII","CLXXXIV","CLXXXV","CLXXXVI","CLXXXVII","CLXXXVIII","CLXXXIX","CXC","CXCI","CXCII","CXCIII","CXCIV","CXCV","CXCVI","CXCVII","CXCVIII","CXCIX","CC","CCI","CCII","CCIII","CCIV","CCV","CCVI","CCVII","CCVIII","CCIX","CCX","CCXI","CCXII","CCXIII","CCXIV","CCXV","CCXVI","CCXVII","CCXVIII","CCXIX","CCXX","CCXXI","CCXXII","CCXXIII","CCXXIV","CCXXV","CCXXVI","CCXXVII","CCXXVIII","CCXXIX","CCXXX","CCXXXI","CCXXXII","CCXXXIII","CCXXXIV","CCXXXV","CCXXXVI","CCXXXVII","CCXXXVIII","CCXXXIX","CCXL","CCXLI","CCXLII","CCXLIII","CCXLIV","CCXLV","CCXLVI","CCXLVII","CCXLVIII","CCXLIX","CCL","CCLI","CCLII","CCLIII","CCLIV","CCLV","CCLVI","CCLVII","CCLVIII","CCLIX","CCLX","CCLXI","CCLXII","CCLXIII","CCLXIV","CCLXV","CCLXVI","CCLXVII","CCLXVIII","CCLXIX","CCLXX","CCLXXI","CCLXXII","CCLXXIII","CCLXXIV","CCLXXV","CCLXXVI","CCLXXVII","CCLXXVIII","CCLXXIX","CCLXXX","CCLXXXI","CCLXXXII","CCLXXXIII","CCLXXXIV","CCLXXXV","CCLXXXVI","CCLXXXVII","CCLXXXVIII","CCLXXXIX","CCXC","CCXCI","CCXCII","CCXCIII","CCXCIV","CCXCV","CCXCVI","CCXCVII","CCXCVIII","CCXCIX","CCC","CCCI","CCCII","CCCIII","CCCIV","CCCV","CCCVI","CCCVII","CCCVIII","CCCIX","CCCX","CCCXI","CCCXII","CCCXIII","CCCXIV","CCCXV","CCCXVI","CCCXVII","CCCXVIII","CCCXIX","CCCXX","CCCXXI","CCCXXII","CCCXXIII","CCCXXIV","CCCXXV","CCCXXVI","CCCXXVII","CCCXXVIII","CCCXXIX","CCCXXX","CCCXXXI","CCCXXXII","CCCXXXIII","CCCXXXIV","CCCXXXV","CCCXXXVI","CCCXXXVII","CCCXXXVIII","CCCXXXIX","CCCXL","CCCXLI","CCCXLII","CCCXLIII","CCCXLIV","CCCXLV","CCCXLVI","CCCXLVII","CCCXLVIII","CCCXLIX","CCCL","CCCLI","CCCLII","CCCLIII","CCCLIV","CCCLV","CCCLVI","CCCLVII","CCCLVIII","CCCLIX","CCCLX","CCCLXI","CCCLXII","CCCLXIII","CCCLXIV","CCCLXV","CCCLXVI","CCCLXVII","CCCLXVIII","CCCLXIX","CCCLXX","CCCLXXI","CCCLXXII","CCCLXXIII","CCCLXXIV","CCCLXXV","CCCLXXVI","CCCLXXVII","CCCLXXVIII","CCCLXXIX","CCCLXXX","CCCLXXXI","CCCLXXXII","CCCLXXXIII","CCCLXXXIV","CCCLXXXV","CCCLXXXVI","CCCLXXXVII","CCCLXXXVIII","CCCLXXXIX","CCCXC","CCCXCI","CCCXCII","CCCXCIII","CCCXCIV","CCCXCV","CCCXCVI","CCCXCVII","CCCXCVIII","CCCXCIX","CD","CDI","CDII","CDIII","CDIV","CDV","CDVI","CDVII","CDVIII","CDIX","CDX","CDXI","CDXII","CDXIII","CDXIV","CDXV","CDXVI","CDXVII","CDXVIII","CDXIX","CDXX","CDXXI","CDXXII","CDXXIII","CDXXIV","CDXXV","CDXXVI","CDXXVII","CDXXVIII","CDXXIX","CDXXX","CDXXXI","CDXXXII","CDXXXIII","CDXXXIV","CDXXXV","CDXXXVI","CDXXXVII","CDXXXVIII","CDXXXIX","CDXL","CDXLI","CDXLII","CDXLIII","CDXLIV","CDXLV","CDXLVI","CDXLVII","CDXLVIII","CDXLIX","CDL","CDLI","CDLII","CDLIII","CDLIV","CDLV","CDLVI","CDLVII","CDLVIII","CDLIX","CDLX","CDLXI","CDLXII","CDLXIII","CDLXIV","CDLXV","CDLXVI","CDLXVII","CDLXVIII","CDLXIX","CDLXX","CDLXXI","CDLXXII","CDLXXIII","CDLXXIV","CDLXXV","CDLXXVI","CDLXXVII","CDLXXVIII","CDLXXIX","CDLXXX","CDLXXXI","CDLXXXII","CDLXXXIII","CDLXXXIV","CDLXXXV","CDLXXXVI","CDLXXXVII","CDLXXXVIII","CDLXXXIX","CDXC","CDXCI","CDXCII","CDXCIII","CDXCIV","CDXCV","CDXCVI","CDXCVII","CDXCVIII","CDXCIX","D","DI","DII","DIII","DIV","DV","DVI","DVII","DVIII","DIX","DX","DXI","DXII","DXIII","DXIV","DXV","DXVI","DXVII","DXVIII","DXIX","DXX","DXXI","DXXII","DXXIII","DXXIV","DXXV","DXXVI","DXXVII","DXXVIII","DXXIX","DXXX","DXXXI","DXXXII","DXXXIII","DXXXIV","DXXXV","DXXXVI","DXXXVII","DXXXVIII","DXXXIX","DXL","DXLI","DXLII","DXLIII","DXLIV","DXLV","DXLVI","DXLVII","DXLVIII","DXLIX","DL","DLI","DLII","DLIII","DLIV","DLV","DLVI","DLVII","DLVIII","DLIX","DLX","DLXI","DLXII","DLXIII","DLXIV","DLXV","DLXVI","DLXVII","DLXVIII","DLXIX","DLXX","DLXXI","DLXXII","DLXXIII","DLXXIV","DLXXV","DLXXVI","DLXXVII","DLXXVIII","DLXXIX","DLXXX","DLXXXI","DLXXXII","DLXXXIII","DLXXXIV","DLXXXV","DLXXXVI","DLXXXVII","DLXXXVIII","DLXXXIX","DXC","DXCI","DXCII","DXCIII","DXCIV","DXCV","DXCVI","DXCVII","DXCVIII","DXCIX","DC","DCI","DCII","DCIII","DCIV","DCV","DCVI","DCVII","DCVIII","DCIX","DCX","DCXI","DCXII","DCXIII","DCXIV","DCXV","DCXVI","DCXVII","DCXVIII","DCXIX","DCXX","DCXXI","DCXXII","DCXXIII","DCXXIV","DCXXV","DCXXVI","DCXXVII","DCXXVIII","DCXXIX","DCXXX","DCXXXI","DCXXXII","DCXXXIII","DCXXXIV","DCXXXV","DCXXXVI","DCXXXVII","DCXXXVIII","DCXXXIX","DCXL","DCXLI","DCXLII","DCXLIII","DCXLIV","DCXLV","DCXLVI","DCXLVII","DCXLVIII","DCXLIX","DCL","DCLI","DCLII","DCLIII","DCLIV","DCLV","DCLVI","DCLVII","DCLVIII","DCLIX","DCLX","DCLXI","DCLXII","DCLXIII","DCLXIV","DCLXV","DCLXVI","DCLXVII","DCLXVIII","DCLXIX","DCLXX","DCLXXI","DCLXXII","DCLXXIII","DCLXXIV","DCLXXV","DCLXXVI","DCLXXVII","DCLXXVIII","DCLXXIX","DCLXXX","DCLXXXI","DCLXXXII","DCLXXXIII","DCLXXXIV","DCLXXXV","DCLXXXVI","DCLXXXVII","DCLXXXVIII","DCLXXXIX","DCXC","DCXCI","DCXCII","DCXCIII","DCXCIV","DCXCV","DCXCVI","DCXCVII","DCXCVIII","DCXCIX","DCC","DCCI","DCCII","DCCIII","DCCIV","DCCV","DCCVI","DCCVII","DCCVIII","DCCIX","DCCX","DCCXI","DCCXII","DCCXIII","DCCXIV","DCCXV","DCCXVI","DCCXVII","DCCXVIII","DCCXIX","DCCXX","DCCXXI","DCCXXII","DCCXXIII","DCCXXIV","DCCXXV","DCCXXVI","DCCXXVII","DCCXXVIII","DCCXXIX","DCCXXX","DCCXXXI","DCCXXXII","DCCXXXIII","DCCXXXIV","DCCXXXV","DCCXXXVI","DCCXXXVII","DCCXXXVIII","DCCXXXIX","DCCXL","DCCXLI","DCCXLII","DCCXLIII","DCCXLIV","DCCXLV","DCCXLVI","DCCXLVII","DCCXLVIII","DCCXLIX","DCCL","DCCLI","DCCLII","DCCLIII","DCCLIV","DCCLV","DCCLVI","DCCLVII","DCCLVIII","DCCLIX","DCCLX","DCCLXI","DCCLXII","DCCLXIII","DCCLXIV","DCCLXV","DCCLXVI","DCCLXVII","DCCLXVIII","DCCLXIX","DCCLXX","DCCLXXI","DCCLXXII","DCCLXXIII","DCCLXXIV","DCCLXXV","DCCLXXVI","DCCLXXVII","DCCLXXVIII","DCCLXXIX","DCCLXXX","DCCLXXXI","DCCLXXXII","DCCLXXXIII","DCCLXXXIV","DCCLXXXV","DCCLXXXVI","DCCLXXXVII","DCCLXXXVIII","DCCLXXXIX","DCCXC","DCCXCI","DCCXCII","DCCXCIII","DCCXCIV","DCCXCV","DCCXCVI","DCCXCVII","DCCXCVIII","DCCXCIX","DCCC","DCCCI","DCCCII","DCCCIII","DCCCIV","DCCCV","DCCCVI","DCCCVII","DCCCVIII","DCCCIX","DCCCX","DCCCXI","DCCCXII","DCCCXIII","DCCCXIV","DCCCXV","DCCCXVI","DCCCXVII","DCCCXVIII","DCCCXIX","DCCCXX","DCCCXXI","DCCCXXII","DCCCXXIII","DCCCXXIV","DCCCXXV","DCCCXXVI","DCCCXXVII","DCCCXXVIII","DCCCXXIX","DCCCXXX","DCCCXXXI","DCCCXXXII","DCCCXXXIII","DCCCXXXIV","DCCCXXXV","DCCCXXXVI","DCCCXXXVII","DCCCXXXVIII","DCCCXXXIX","DCCCXL","DCCCXLI","DCCCXLII","DCCCXLIII","DCCCXLIV","DCCCXLV","DCCCXLVI","DCCCXLVII","DCCCXLVIII","DCCCXLIX","DCCCL","DCCCLI","DCCCLII","DCCCLIII","DCCCLIV","DCCCLV","DCCCLVI","DCCCLVII","DCCCLVIII","DCCCLIX","DCCCLX","DCCCLXI","DCCCLXII","DCCCLXIII","DCCCLXIV","DCCCLXV","DCCCLXVI","DCCCLXVII","DCCCLXVIII","DCCCLXIX","DCCCLXX","DCCCLXXI","DCCCLXXII","DCCCLXXIII","DCCCLXXIV","DCCCLXXV","DCCCLXXVI","DCCCLXXVII","DCCCLXXVIII","DCCCLXXIX","DCCCLXXX","DCCCLXXXI","DCCCLXXXII","DCCCLXXXIII","DCCCLXXXIV","DCCCLXXXV","DCCCLXXXVI","DCCCLXXXVII","DCCCLXXXVIII","DCCCLXXXIX","DCCCXC","DCCCXCI","DCCCXCII","DCCCXCIII","DCCCXCIV","DCCCXCV","DCCCXCVI","DCCCXCVII","DCCCXCVIII","DCCCXCIX","CM","CMI","CMII","CMIII","CMIV","CMV","CMVI","CMVII","CMVIII","CMIX","CMX","CMXI","CMXII","CMXIII","CMXIV","CMXV","CMXVI","CMXVII","CMXVIII","CMXIX","CMXX","CMXXI","CMXXII","CMXXIII","CMXXIV","CMXXV","CMXXVI","CMXXVII","CMXXVIII","CMXXIX","CMXXX","CMXXXI","CMXXXII","CMXXXIII","CMXXXIV","CMXXXV","CMXXXVI","CMXXXVII","CMXXXVIII","CMXXXIX","CMXL","CMXLI","CMXLII","CMXLIII","CMXLIV","CMXLV","CMXLVI","CMXLVII","CMXLVIII","CMXLIX","CML","CMLI","CMLII","CMLIII","CMLIV","CMLV","CMLVI","CMLVII","CMLVIII","CMLIX","CMLX","CMLXI","CMLXII","CMLXIII","CMLXIV","CMLXV","CMLXVI","CMLXVII","CMLXVIII","CMLXIX","CMLXX","CMLXXI","CMLXXII","CMLXXIII","CMLXXIV","CMLXXV","CMLXXVI","CMLXXVII","CMLXXVIII","CMLXXIX","CMLXXX","CMLXXXI","CMLXXXII","CMLXXXIII","CMLXXXIV","CMLXXXV","CMLXXXVI","CMLXXXVII","CMLXXXVIII","CMLXXXIX","CMXC","CMXCI","CMXCII","CMXCIII","CMXCIV","CMXCV","CMXCVI","CMXCVII","CMXCVIII","CMXCIX","M"];
var romanSmallNumbers = ["i","ii","iii","iv","v","vi","vii","viii","ix","x","xi","xii","xiii","xiv","xv","xvi","xvii","xviii","xix","xx","xxi","xxii","xxiii","xxiv","xxv","xxvi","xxvii","xxviii","xxix","xxx","xxxi","xxxii","xxxiii","xxxiv","xxxv","xxxvi","xxxvii","xxxviii","xxxix","xl","xli","xlii","xliii","xliv","xlv","xlvi","xlvii","xlviii","xlix","l","li","lii","liii","liv","lv","lvi","lvii","lviii","lix","lx","lxi","lxii","lxiii","lxiv","lxv","lxvi","lxvii","lxviii","lxix","lxx","lxxi","lxxii","lxxiii","lxxiv","lxxv","lxxvi","lxxvii","lxxviii","lxxix","lxxx","lxxxi","lxxxii","lxxxiii","lxxxiv","lxxxv","lxxxvi","lxxxvii","lxxxviii","lxxxix","xc","xci","xcii","xciii","xciv","xcv","xcvi","xcvii","xcviii","xcix","c","ci","cii","ciii","civ","cv","cvi","cvii","cviii","cix","cx","cxi","cxii","cxiii","cxiv","cxv","cxvi","cxvii","cxviii","cxix","cxx","cxxi","cxxii","cxxiii","cxxiv","cxxv","cxxvi","cxxvii","cxxviii","cxxix","cxxx","cxxxi","cxxxii","cxxxiii","cxxxiv","cxxxv","cxxxvi","cxxxvii","cxxxviii","cxxxix","cxl","cxli","cxlii","cxliii","cxliv","cxlv","cxlvi","cxlvii","cxlviii","cxlix","cl","cli","clii","cliii","cliv","clv","clvi","clvii","clviii","clix","clx","clxi","clxii","clxiii","clxiv","clxv","clxvi","clxvii","clxviii","clxix","clxx","clxxi","clxxii","clxxiii","clxxiv","clxxv","clxxvi","clxxvii","clxxviii","clxxix","clxxx","clxxxi","clxxxii","clxxxiii","clxxxiv","clxxxv","clxxxvi","clxxxvii","clxxxviii","clxxxix","cxc","cxci","cxcii","cxciii","cxciv","cxcv","cxcvi","cxcvii","cxcviii","cxcix","cc","cci","ccii","cciii","cciv","ccv","ccvi","ccvii","ccviii","ccix","ccx","ccxi","ccxii","ccxiii","ccxiv","ccxv","ccxvi","ccxvii","ccxviii","ccxix","ccxx","ccxxi","ccxxii","ccxxiii","ccxxiv","ccxxv","ccxxvi","ccxxvii","ccxxviii","ccxxix","ccxxx","ccxxxi","ccxxxii","ccxxxiii","ccxxxiv","ccxxxv","ccxxxvi","ccxxxvii","ccxxxviii","ccxxxix","ccxl","ccxli","ccxlii","ccxliii","ccxliv","ccxlv","ccxlvi","ccxlvii","ccxlviii","ccxlix","ccl","ccli","cclii","ccliii","ccliv","cclv","cclvi","cclvii","cclviii","cclix","cclx","cclxi","cclxii","cclxiii","cclxiv","cclxv","cclxvi","cclxvii","cclxviii","cclxix","cclxx","cclxxi","cclxxii","cclxxiii","cclxxiv","cclxxv","cclxxvi","cclxxvii","cclxxviii","cclxxix","cclxxx","cclxxxi","cclxxxii","cclxxxiii","cclxxxiv","cclxxxv","cclxxxvi","cclxxxvii","cclxxxviii","cclxxxix","ccxc","ccxci","ccxcii","ccxciii","ccxciv","ccxcv","ccxcvi","ccxcvii","ccxcviii","ccxcix","ccc","ccci","cccii","ccciii","ccciv","cccv","cccvi","cccvii","cccviii","cccix","cccx","cccxi","cccxii","cccxiii","cccxiv","cccxv","cccxvi","cccxvii","cccxviii","cccxix","cccxx","cccxxi","cccxxii","cccxxiii","cccxxiv","cccxxv","cccxxvi","cccxxvii","cccxxviii","cccxxix","cccxxx","cccxxxi","cccxxxii","cccxxxiii","cccxxxiv","cccxxxv","cccxxxvi","cccxxxvii","cccxxxviii","cccxxxix","cccxl","cccxli","cccxlii","cccxliii","cccxliv","cccxlv","cccxlvi","cccxlvii","cccxlviii","cccxlix","cccl","cccli","ccclii","cccliii","cccliv","ccclv","ccclvi","ccclvii","ccclviii","ccclix","ccclx","ccclxi","ccclxii","ccclxiii","ccclxiv","ccclxv","ccclxvi","ccclxvii","ccclxviii","ccclxix","ccclxx","ccclxxi","ccclxxii","ccclxxiii","ccclxxiv","ccclxxv","ccclxxvi","ccclxxvii","ccclxxviii","ccclxxix","ccclxxx","ccclxxxi","ccclxxxii","ccclxxxiii","ccclxxxiv","ccclxxxv","ccclxxxvi","ccclxxxvii","ccclxxxviii","ccclxxxix","cccxc","cccxci","cccxcii","cccxciii","cccxciv","cccxcv","cccxcvi","cccxcvii","cccxcviii","cccxcix","cd","cdi","cdii","cdiii","cdiv","cdv","cdvi","cdvii","cdviii","cdix","cdx","cdxi","cdxii","cdxiii","cdxiv","cdxv","cdxvi","cdxvii","cdxviii","cdxix","cdxx","cdxxi","cdxxii","cdxxiii","cdxxiv","cdxxv","cdxxvi","cdxxvii","cdxxviii","cdxxix","cdxxx","cdxxxi","cdxxxii","cdxxxiii","cdxxxiv","cdxxxv","cdxxxvi","cdxxxvii","cdxxxviii","cdxxxix","cdxl","cdxli","cdxlii","cdxliii","cdxliv","cdxlv","cdxlvi","cdxlvii","cdxlviii","cdxlix","cdl","cdli","cdlii","cdliii","cdliv","cdlv","cdlvi","cdlvii","cdlviii","cdlix","cdlx","cdlxi","cdlxii","cdlxiii","cdlxiv","cdlxv","cdlxvi","cdlxvii","cdlxviii","cdlxix","cdlxx","cdlxxi","cdlxxii","cdlxxiii","cdlxxiv","cdlxxv","cdlxxvi","cdlxxvii","cdlxxviii","cdlxxix","cdlxxx","cdlxxxi","cdlxxxii","cdlxxxiii","cdlxxxiv","cdlxxxv","cdlxxxvi","cdlxxxvii","cdlxxxviii","cdlxxxix","cdxc","cdxci","cdxcii","cdxciii","cdxciv","cdxcv","cdxcvi","cdxcvii","cdxcviii","cdxcix","d","di","dii","diii","div","dv","dvi","dvii","dviii","dix","dx","dxi","dxii","dxiii","dxiv","dxv","dxvi","dxvii","dxviii","dxix","dxx","dxxi","dxxii","dxxiii","dxxiv","dxxv","dxxvi","dxxvii","dxxviii","dxxix","dxxx","dxxxi","dxxxii","dxxxiii","dxxxiv","dxxxv","dxxxvi","dxxxvii","dxxxviii","dxxxix","dxl","dxli","dxlii","dxliii","dxliv","dxlv","dxlvi","dxlvii","dxlviii","dxlix","dl","dli","dlii","dliii","dliv","dlv","dlvi","dlvii","dlviii","dlix","dlx","dlxi","dlxii","dlxiii","dlxiv","dlxv","dlxvi","dlxvii","dlxviii","dlxix","dlxx","dlxxi","dlxxii","dlxxiii","dlxxiv","dlxxv","dlxxvi","dlxxvii","dlxxviii","dlxxix","dlxxx","dlxxxi","dlxxxii","dlxxxiii","dlxxxiv","dlxxxv","dlxxxvi","dlxxxvii","dlxxxviii","dlxxxix","dxc","dxci","dxcii","dxciii","dxciv","dxcv","dxcvi","dxcvii","dxcviii","dxcix","dc","dci","dcii","dciii","dciv","dcv","dcvi","dcvii","dcviii","dcix","dcx","dcxi","dcxii","dcxiii","dcxiv","dcxv","dcxvi","dcxvii","dcxviii","dcxix","dcxx","dcxxi","dcxxii","dcxxiii","dcxxiv","dcxxv","dcxxvi","dcxxvii","dcxxviii","dcxxix","dcxxx","dcxxxi","dcxxxii","dcxxxiii","dcxxxiv","dcxxxv","dcxxxvi","dcxxxvii","dcxxxviii","dcxxxix","dcxl","dcxli","dcxlii","dcxliii","dcxliv","dcxlv","dcxlvi","dcxlvii","dcxlviii","dcxlix","dcl","dcli","dclii","dcliii","dcliv","dclv","dclvi","dclvii","dclviii","dclix","dclx","dclxi","dclxii","dclxiii","dclxiv","dclxv","dclxvi","dclxvii","dclxviii","dclxix","dclxx","dclxxi","dclxxii","dclxxiii","dclxxiv","dclxxv","dclxxvi","dclxxvii","dclxxviii","dclxxix","dclxxx","dclxxxi","dclxxxii","dclxxxiii","dclxxxiv","dclxxxv","dclxxxvi","dclxxxvii","dclxxxviii","dclxxxix","dcxc","dcxci","dcxcii","dcxciii","dcxciv","dcxcv","dcxcvi","dcxcvii","dcxcviii","dcxcix","dcc","dcci","dccii","dcciii","dcciv","dccv","dccvi","dccvii","dccviii","dccix","dccx","dccxi","dccxii","dccxiii","dccxiv","dccxv","dccxvi","dccxvii","dccxviii","dccxix","dccxx","dccxxi","dccxxii","dccxxiii","dccxxiv","dccxxv","dccxxvi","dccxxvii","dccxxviii","dccxxix","dccxxx","dccxxxi","dccxxxii","dccxxxiii","dccxxxiv","dccxxxv","dccxxxvi","dccxxxvii","dccxxxviii","dccxxxix","dccxl","dccxli","dccxlii","dccxliii","dccxliv","dccxlv","dccxlvi","dccxlvii","dccxlviii","dccxlix","dccl","dccli","dcclii","dccliii","dccliv","dcclv","dcclvi","dcclvii","dcclviii","dcclix","dcclx","dcclxi","dcclxii","dcclxiii","dcclxiv","dcclxv","dcclxvi","dcclxvii","dcclxviii","dcclxix","dcclxx","dcclxxi","dcclxxii","dcclxxiii","dcclxxiv","dcclxxv","dcclxxvi","dcclxxvii","dcclxxviii","dcclxxix","dcclxxx","dcclxxxi","dcclxxxii","dcclxxxiii","dcclxxxiv","dcclxxxv","dcclxxxvi","dcclxxxvii","dcclxxxviii","dcclxxxix","dccxc","dccxci","dccxcii","dccxciii","dccxciv","dccxcv","dccxcvi","dccxcvii","dccxcviii","dccxcix","dccc","dccci","dcccii","dccciii","dccciv","dcccv","dcccvi","dcccvii","dcccviii","dcccix","dcccx","dcccxi","dcccxii","dcccxiii","dcccxiv","dcccxv","dcccxvi","dcccxvii","dcccxviii","dcccxix","dcccxx","dcccxxi","dcccxxii","dcccxxiii","dcccxxiv","dcccxxv","dcccxxvi","dcccxxvii","dcccxxviii","dcccxxix","dcccxxx","dcccxxxi","dcccxxxii","dcccxxxiii","dcccxxxiv","dcccxxxv","dcccxxxvi","dcccxxxvii","dcccxxxviii","dcccxxxix","dcccxl","dcccxli","dcccxlii","dcccxliii","dcccxliv","dcccxlv","dcccxlvi","dcccxlvii","dcccxlviii","dcccxlix","dcccl","dcccli","dccclii","dcccliii","dcccliv","dccclv","dccclvi","dccclvii","dccclviii","dccclix","dccclx","dccclxi","dccclxii","dccclxiii","dccclxiv","dccclxv","dccclxvi","dccclxvii","dccclxviii","dccclxix","dccclxx","dccclxxi","dccclxxii","dccclxxiii","dccclxxiv","dccclxxv","dccclxxvi","dccclxxvii","dccclxxviii","dccclxxix","dccclxxx","dccclxxxi","dccclxxxii","dccclxxxiii","dccclxxxiv","dccclxxxv","dccclxxxvi","dccclxxxvii","dccclxxxviii","dccclxxxix","dcccxc","dcccxci","dcccxcii","dcccxciii","dcccxciv","dcccxcv","dcccxcvi","dcccxcvii","dcccxcviii","dcccxcix","cm","cmi","cmii","cmiii","cmiv","cmv","cmvi","cmvii","cmviii","cmix","cmx","cmxi","cmxii","cmxiii","cmxiv","cmxv","cmxvi","cmxvii","cmxviii","cmxix","cmxx","cmxxi","cmxxii","cmxxiii","cmxxiv","cmxxv","cmxxvi","cmxxvii","cmxxviii","cmxxix","cmxxx","cmxxxi","cmxxxii","cmxxxiii","cmxxxiv","cmxxxv","cmxxxvi","cmxxxvii","cmxxxviii","cmxxxix","cmxl","cmxli","cmxlii","cmxliii","cmxliv","cmxlv","cmxlvi","cmxlvii","cmxlviii","cmxlix","cml","cmli","cmlii","cmliii","cmliv","cmlv","cmlvi","cmlvii","cmlviii","cmlix","cmlx","cmlxi","cmlxii","cmlxiii","cmlxiv","cmlxv","cmlxvi","cmlxvii","cmlxviii","cmlxix","cmlxx","cmlxxi","cmlxxii","cmlxxiii","cmlxxiv","cmlxxv","cmlxxvi","cmlxxvii","cmlxxviii","cmlxxix","cmlxxx","cmlxxxi","cmlxxxii","cmlxxxiii","cmlxxxiv","cmlxxxv","cmlxxxvi","cmlxxxvii","cmlxxxviii","cmlxxxix","cmxc","cmxci","cmxcii","cmxciii","cmxciv","cmxcv","cmxcvi","cmxcvii","cmxcviii","cmxcix","m"];
if (number > 1000) {
    alert(_restriction4);
    return null;
    }
index = Number(number) - 1;
if (format == "LOWER_ROMAN")  rN = romanSmallNumbers[index]; else rN = romanBigNumbers[index];
return rN;
} //  // getRomanNumber
/////////


